package com.dsic.gj_erp.wsclient.handler;

import cn.hutool.cron.CronUtil;
import cn.hutool.cron.task.Task;
import com.alibaba.fastjson.JSONObject;
import com.dsic.gj_erp.wsclient.Message;
import com.dsic.gj_erp.wsclient.WebSocketService;
import lombok.Getter;
import lombok.RequiredArgsConstructor;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

@Service
@RequiredArgsConstructor
public class HeartHandler implements IHandlerService{

    private final WebSocketService webSocketService;

    private boolean scheduleStartFlag=false;

    @Value("${ws.client.url}")
    private String url;

    @Getter
    @Value("${ws.client.id}")
    private String erpId;

    @Override
    public boolean execute(Message message) {
        if (this.scheduleStartFlag){
            return true;
        }
        CronUtil.schedule("*/10 * * * * *", (Task) () -> {
            try {
                System.out.println("心跳");
                webSocketService.sendMessage(message.toString());
            } catch (Exception e) {
                if (webSocketService.getSession()==null){
                    webSocketService.connect(this.url);
                    try {
                        webSocketService.sendMessage(Message.reg(this.erpId).toString());
                    } catch (Exception ex) {
                        throw new RuntimeException(ex);
                    }
                }
                e.printStackTrace();
            }
        });

        // 支持秒级别定时任务
        CronUtil.setMatchSecond(true);
        CronUtil.start();
        this.scheduleStartFlag=true;
        return true;
    }
}
